"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const basicsocket_1 = require("basicsocket");
const app_1 = require("./../app");
class OnLoad {
    constructor() {
        let uniqueSocket = basicsocket_1.UniqueSocket.getInstance();
        let socket = uniqueSocket.getBasicSocket();
        socket.setIdentification({ type: 'app' });
        let app;
        socket.on('getIdentification', (key) => {
            socket.setKey(key);
            socket.emit('identification', socket.getIdentification());
            if (app === undefined) {
                app = new app_1.App();
            }
        });
        socket.on('reconnect_attempt', () => {
            console.log('Reconnect Attempt');
            if (app === undefined) {
                app = new app_1.App();
            }
        });
    }
}
exports.OnLoad = OnLoad;
//# sourceMappingURL=onLoad.js.map