import 'simpleutils';
import { Child } from '../child/child';
export declare class AppObject extends Child {
    private static types;
    page: string;
    notificationName: string;
    view: ComponentView;
    pageFrame: ComponentPageFrame;
    checkPageFrame: boolean;
    checkView: boolean;
    checkNotification: boolean;
    static getTypes(): any;
    static getInstance(geneticCode?: GeneticCode): AppObject;
    static addType(type: any): void;
    static addConstructor(constructor: any): void;
    constructor(geneticCode?: GeneticCode);
    protected getConstructor(): Function;
    getPageFrame(): ComponentPageFrame;
    getView(): ComponentView;
    getPage(): string;
    getPageBody(): import("../../body/componentPageBody").ComponentPageBody;
    getHeader(): import("../../../..").ComponentRouter;
    getFooter(): import("../../../..").ComponentRouter;
    getNotification(): import("../../../..").ComponentRouter;
    getNotificationName(): string;
    protected clearProperty(property: any): void;
    protected generateElementStyleFromJSON(jSON: any, property: any): void;
    protected generateElementVarFromJSON(jSON: any, property: any): void;
    protected generateNotElementStyleFromJSON(jSON: any, property: any): void;
    protected generateArrayFromJSON(jSON: any, property: any): void;
    protected generateObjectsFromJSONArrayProperty(jSON: any, property: any): void;
    protected generateElementsFromJSONArrayProperty(jSON: any, property: any): void;
    protected generateObjectFromJSON(jSON: any, property: any): void;
    protected generateElementFromJSON(jSON: any, property: any): void;
    protected generateWithTypeFromJSON(jSON: any, property: any, type: JSONObjectType): void;
    protected generateWithoutTypeFromJSON(jSON: any, property: any): void;
    protected getProperty(property: any): any;
    protected setProperty(property: any, value: any): void;
    protected populateRegularPropertyFromJSON(jSON: any, property: any): void;
    protected generateRegularPropertyFromJSON(jSON: any, property: any): void;
    protected generatePropertyFromJSON(jSON: any, property: any): void;
    protected populatePropertyFromJSON(jSON: any, property: any, type?: JSONObjectType): void;
    protected generateFromJSON(jSON: any, type?: JSONObjectType): void;
    populate(jSON: any): void;
    protected setProperties(): void;
    renderBeforeUpdate(): void;
    renderAfterUpdate(): void;
    setCurrentLanguage(language: string): void;
    getCurrentLanguage(): any;
    getArrayType(array: Array<any>): any;
    getNameFromArrayName(arrayName: string): string;
    setPageFrame(): void;
    private setView;
    private setPage;
    private setNotificationName;
}
import { ComponentView } from './../../componentView';
import { ComponentPageFrame } from '../../page/componentPageFrame';
import { JSONObjectType } from './jSONObjectType';
import { GeneticCode } from '../child/geneticCode';
