"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const appObject_1 = require("../appObject");
const appObjectFactory_1 = require("../factory/appObjectFactory");
const $ = require("jquery");
class Event extends appObject_1.AppObject {
    constructor(geneticCode) {
        super(Object.assign({ className: 'Event' }, geneticCode));
        this.verified = true;
    }
    renderAfterUpdate() {
        if (this.event !== undefined) {
            switch (this.event) {
                case 'build':
                    this.onLoad();
                    break;
                case 'router':
                    this.addEventListener('click');
                    break;
                case 'authorization':
                    this.auth(this.onEvent());
                    this.subscribe();
                    break;
                default:
                    this.addEventListener(this.event);
                    break;
            }
        }
    }
    onLoad() {
        let _self = this;
        if (_self.builder === null || _self.builder === undefined || _self.builder === '') {
            let element = _self.getFather().getElement();
            element.onload = _self.onEvent();
        }
        else {
            switch (_self.builder) {
                case 'window':
                    window.onload = _self.onEvent();
                    break;
                case 'document':
                    $(document).ready = _self.onEvent();
                    break;
                default:
                    if (_self.eventListener) {
                        _self.onEvent();
                        _self.addEventListener(_self.builder);
                    }
                    else {
                        // tslint:disable-next-line: no-eval
                        eval('_self.builder' + '=' + _self.onEvent() + ';');
                        break;
                    }
            }
        }
        _self.running = true;
    }
    auth(verified) {
        if (verified) {
            this.activateFather();
        }
        else {
            this.deactivateFather();
        }
        this.verified = verified;
    }
    deactivateFather() {
        // console.log('FATHER DESTROY:', this.father, this);
        if (this.verified) {
            this.father.destroyElement();
            // delete this.father;
        }
    }
    activateFather() {
        // console.log('FATHER DESTROY:', this.father, this);
        if (!this.verified) {
            (this.father).getFather().insert(this.father);
        }
    }
    checkLink(runFunction) {
        if (runFunction(this.link)) {
            return this.link;
        }
        return null;
    }
    addEventListener(event) {
        let _self = this;
        let element = this.getFather().getElement();
        element.addEventListener(event, () => _self.onEvent());
    }
    onEvent() {
        if (this.code !== undefined && this.runFunction !== undefined) {
            let appObject = appObjectFactory_1.AppObjectFactory.create(this.code, { father: this });
            for (let property in this.appObject) {
                if (this.appObject.hasOwnProperty(property)) {
                    appObject[property] = this.appObject[property];
                }
            }
            this.appObject = appObject;
            // console.log('CODE:' + this.code);
            if (this.link !== undefined) {
                // tslint:disable-next-line: no-eval
                let link = this.checkLink(eval('appObject' + '.' + this.runFunction));
                if (link !== undefined && link !== null) {
                    this.getView().goToPage(link);
                }
                return link;
            }
            else {
                // tslint:disable-next-line: no-eval
                return eval('appObject' + '.' + this.runFunction);
            }
        }
        else {
            if (this.link !== undefined) {
                this.getView().goToPage(this.link);
                return this.link;
            }
        }
    }
    subscribe() {
        let appObject;
        let _self = this;
        let code = _self.code;
        let runFunction = _self.runFunction;
        if (_self.subscribeCode !== undefined) {
            code = _self.subscribeCode;
        }
        if (_self.subscribeFunction !== undefined) {
            runFunction = _self.subscribeFunction;
        }
        appObject = appObjectFactory_1.AppObjectFactory.create(code, { father: _self });
        // tslint:disable-next-line: no-eval
        eval('appObject' + '.' + runFunction + '((data) => { _self.auth(data); })');
    }
}
exports.Event = Event;
Event.addConstructor(Event);
//# sourceMappingURL=event.js.map