"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("simpleutils");
const basicutil_1 = require("basicutil");
const appObject_1 = require("./../appObject/appObject");
class Component extends appObject_1.AppObject {
    constructor(geneticCode) {
        super(Object.assign({ className: 'Component' }, geneticCode));
    }
    getTag() {
        return this.basicViewModel.getElement().tagName;
    }
    // public setFather(father) {
    //   super.setFather(father);
    //   if (father) {
    //     // console.log('this.father.tag:' + this.father.tag);
    //     this.insert(father);
    //     father.renderAfterUpdate();
    //   }
    // }
    getForm() {
        if (!this.formChecked) {
            this.setForm();
        }
        return this.form;
    }
    getElement() {
        return this.basicViewModel.getElement();
    }
    isElementInnerHTMLEmpty() {
        return (!this.basicViewModel.getElement().innerHTML || this.basicViewModel.getElement().innerHTML === undefined || this.basicViewModel.getElement().innerHTML === 'undefined');
    }
    cleanElementInnerHTML() {
        if (this.isElementInnerHTMLEmpty()) {
            this.clearElementInnerHTML();
        }
    }
    clearElementInnerHTML() {
        this.basicViewModel.getElement().innerHTML = '';
    }
    setElementSource(source) {
        let tmp = this.basicViewModel.getElement();
        tmp.src = source;
    }
    insertOn(father) {
        if (typeof father.getElement === 'function')
            this.insertElementOn(father.getElement());
    }
    insert(child) {
        if (typeof child.getElement === 'function')
            this.insertElement(child.getElement());
    }
    remove(child) {
        if (typeof child.getElement === 'function')
            this.removeElement(child.getElement());
    }
    insertElementOn(fatherElement) {
        // this.render();
        // console.log('FATHER:' + fatherElement.tagName);
        // console.log('this:' + this.getClassName());
        fatherElement.appendChild(this.basicViewModel.getElement());
    }
    insertElement(element) {
        // this.render();
        // console.log('FATHER:' + fatherElement.tagName);
        // console.log('this:' + this.getClassName());
        this.basicViewModel.getElement().appendChild(element);
    }
    removeElement(element) {
        // this.render();
        // console.log('FATHER:' + fatherElement.tagName);
        // console.log('this:' + this.getClassName());
        this.basicViewModel.getElement().removeChild(element);
    }
    destroyElement() {
        let element = document.getElementById(this.basicViewModel.getElement().id);
        if (element === undefined || element === null) {
            if (this.basicViewModel.getElement() !== undefined && this.basicViewModel.getElement() !== null) {
                this.basicViewModel.getElement().remove(); // parentElement.removeChild(element);
                // this.element.outerHTML = "";
            }
        }
        else {
            element.remove(); // .parentElement.removeChild(element);
            // element.outerHTML = "";
        }
    }
    destroyChildElements() {
        let range = document.createRange();
        range.selectNodeContents(this.basicViewModel.getElement());
        range.deleteContents();
    }
    initGeneticCode(geneticCode) {
        let _self = this;
        geneticCode = super.initGeneticCode(geneticCode);
        _self.basicViewModel = new basicViewModel_1.BasicViewModel(geneticCode);
        _self.basicViewModel.init();
        _self.getItem();
        return geneticCode;
    }
    setForm() {
        this.form = this.seekFather('ComponentForm');
        this.formChecked = true;
    }
    clearProperty(property) {
        if (this.getProperty(property).length > 0) {
            // console.log('CLEAR');
            // console.log(property);
            // console.log(this[property][0].getTag());
            let elements = this.basicViewModel.getElement().getElementsByTagName(this.getProperty(property)[0].getTag());
            basicutil_1.Util.getInstance().removeElements(elements);
            this.getProperty(property).length = 0;
        }
    }
    generateElementStyleFromJSON(jSON, property) {
        this.basicViewModel.getElement().style[property] = jSON[property];
    }
    generateElementVarFromJSON(jSON, property) {
        // this.element[property] = jSON[property];
        this.basicViewModel.getElement().setAttribute(property, jSON[property]);
    }
    setProperties() {
        if (this.properties)
            for (const property of Object.keys(this.properties)) {
                let value = this.getPropertyValue(this.properties[property]);
                this.basicViewModel.setAttributeValue(property, value);
            }
    }
    getPropertyValue(variable) {
        if (this.father && this.father instanceof Component && this.father.properties && this.father.properties[variable]) {
            return this.father.getPropertyValue(this.father.properties[variable]);
        }
        return this.getLanguagePropertyValue(variable);
    }
    getLanguagePropertyValue(variable) {
        let pageFrame = this.getPageFrame();
        if (pageFrame !== undefined) {
            return this.getLanguagePropertyValueFromJSON(pageFrame.getFullPage().getCurrentLanguageJSON(), variable);
        }
        return variable;
    }
    getLanguagePropertyValueFromJSON(jSON, variable) {
        if (jSON[variable]) {
            return jSON[variable];
        }
        return variable;
    }
    getItem() {
        this.item = this.seekFather('ComponentItem');
    }
}
exports.Component = Component;
const basicViewModel_1 = require("../basicViewModel/basicViewModel");
Component.addConstructor(Component);
//# sourceMappingURL=component.js.map